/* ԳοSTC32GʾидעͷļΪ "STC8051U.h" */

#include "STC8051U.h"

#include "stdio.h"
#include "intrins.h"

typedef 	unsigned char	u8;
typedef 	unsigned int	u16;
typedef 	unsigned long	u32;

#define MAIN_Fosc        24000000UL
/****************************** û ***********************************/
#define Timer0_Reload   (MAIN_Fosc / 1000)      //Timer 0 жƵ, 1000/

#define DIS_DOT     0x20
#define DIS_BLACK   0x10
#define DIS_        0x11

sbit    LED_EN = P4^0;  //LEDdԴ

sbit    DS = P3^4;  //SER
sbit    ST_CP = P3^5;  //RCK/STCP12PIN洢Ĵʱ룬ʱλĴݽݴ洢Ĵ½ʱ洢Ĵݲ䡣
sbit    SH_CP = P3^2;  //SCK/SHCP11PINλĴʱ룬ʱݼĴݽλ
/*ƽŵĵƽõͣҪλʱͰSH_CPһ£ҪʱͰST_CPһ*/

/*****************************************************************************/

/*************  س    **************/
/*
--dp g f e d c b a
0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F, 0x77, 0x7C, 0x39, 0x5E, 0x7B, 0x71

--dp g f e d c b a
0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90, 0x88, 0x83, 0xC6, 0xA1, 0x84, 0x8E
*/
u8 code t_display[]={                       //׼ֿ
//   0    1    2    3    4    5    6    7    8    9    A    B    C    D    E    F
    0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71,
//black  -     H    J    K    L    N    o   P    U     t    G    Q    r   M    y
    0x00,0x40,0x76,0x1E,0x70,0x38,0x37,0x5C,0x73,0x3E,0x78,0x3d,0x67,0x50,0x37,0x6e,
    0xBF,0x86,0xDB,0xCF,0xE6,0xED,0xFD,0x87,0xFF,0xEF,0x46};    //0. 1. 2. 3. 4. 5. 6. 7. 8. 9. -1

u8 code T_COM[]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};      //λ

/*************  ر    **************/
u8  LED8[8];        //ʾ
u8  display_index;  //ʾλ
bit B_1ms;          //1ms־

u8  hour,minute,second;
u16 msecond;

/*************  غ    **************/
void    Timer0_init(void);

/********************** ʾʱӺ ************************/
void DisplayRTC(void)
{
    if(hour >= 10)  LED8[0] = hour / 10;
    else            LED8[0] = DIS_BLACK;
    LED8[1] = hour % 10;
    LED8[2] = DIS_;
    LED8[3] = minute / 10;
    LED8[4] = minute % 10;
    LED8[5] = DIS_;
    LED8[6] = second / 10;
    LED8[7] = second % 10;
}

/********************** RTCʾ ************************/
void RTC(void)
{
    if(++second >= 60)
    {
        second = 0;
        if(++minute >= 60)
        {
            minute = 0;
            if(++hour >= 24)    hour = 0;
        }
    }
}

/********************  **************************/
void main(void)
{
    u8  i;
    
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫

    EA = 1;     //ж
		LED_EN = 0; //LEDԴ
		
		Timer0_init();
	
		display_index = 0;
    hour   = 11;    //ʼʱֵ
    minute = 59;
    second = 58;
    RTC();
    DisplayRTC();
		
//    for(i=0; i<8; i++)  LED8[i] = DIS_BLACK;    //ϵ
    for(i=0; i<8; i++)  LED8[i] = i;    //ʾ01234567
	
		while(1)
		{
				if(B_1ms)   //1ms
        {
            B_1ms = 0;
            if(++msecond >= 1000)   //1뵽
            {
                msecond = 0;
                RTC();
                DisplayRTC();
            }
        }
		}
}

//д74HC595
void HC595_WD(u8 dis_data)
{
	u8 i, temp;
	
	temp = dis_data;
	
	for(i=0; i<8; i++)
	{
		SH_CP = 0;
		
		if(temp & 0x80)
			DS = 1;
		else
			DS = 0;
		
		temp = temp << 1;
		
		SH_CP = 1;
		_nop_();
	}
	
	_nop_();
	SH_CP = 0;
}

//д뵽Ĵ˿ʾ
void HC595_OUT(void)
{
	ST_CP = 0;
	_nop_();_nop_();
	ST_CP = 1;
	
	_nop_();
	ST_CP = 0;
}

/********************** ʾɨ躯 ************************/
void DisplayScan(void)
{   
	//ע⣬ԭͼƣддλ
	//ע2ԪĺӣĻҪȡȥȡ
	HC595_WD(~t_display[LED8[display_index]]);	//д		//עȡ
	HC595_WD(T_COM[display_index]);					//дλ		//עȡ
	HC595_OUT();
	
	if(++display_index >= 8)    display_index = 0;  //8λ0
	
	/*test
	HC595_WD(0xB0);
	HC595_WD(0x01);
	HC595_OUT();*/
}

//========================================================================
// : void Timer0_init(void)
// : timer0ʼ.
// : none.
// : none.
// 汾: V1.0, 2015-1-12
//========================================================================
void Timer0_init(void)
{
        TR0 = 0;    //ֹͣ

    #if (Timer0_Reload < 64)    // ûֵʣ ʱ
        #error "Timer0õжϹ!"

    #elif ((Timer0_Reload/12) < 65536UL)    // ûֵʣ ʱ
        ET0 = 1;    //ж
    //  PT0 = 1;    //ȼж
        TMOD &= ~0x03;
        TMOD |= 0;  //ģʽ, 0: 16λԶװ, 1: 16λʱ/, 2: 8λԶװ, 3: 16λԶװ, ж
    //  T0_CT = 1;  //
        T0_CT = 0;  //ʱ
    //  T0CLKO = 1; //ʱ
        T0CLKO = 0; //ʱ

        #if (Timer0_Reload < 65536UL)
            T0x12 = 1;  //1T mode
            TH0 = (u8)((65536UL - Timer0_Reload) / 256);
            TL0 = (u8)((65536UL - Timer0_Reload) % 256);
        #else
            T0x12 = 0;  //12T mode
            TH0 = (u8)((65536UL - Timer0_Reload/12) / 256);
            TL0 = (u8)((65536UL - Timer0_Reload/12) % 256);
        #endif

        TR0 = 1;    //ʼ

    #else
        #error "Timer0õжϹ!"
    #endif
}

//========================================================================
// : void timer0_int (void) interrupt TIMER0_VECTOR
// :  timer0жϺ.
// : none.
// : none.
// 汾: V1.0, 2015-1-12
//========================================================================
void timer0_int (void) interrupt 1
{
	DisplayScan();  //1msɨʾһλ
  B_1ms = 1;      //1ms־
}
